package com.zhibao.crm.utils;

import com.alibaba.fastjson.JSONObject;
import com.jfinal.plugin.activerecord.ActiveRecordPlugin;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.DbKit;
import com.jfinal.plugin.activerecord.Record;
import com.jfinal.plugin.druid.DruidPlugin;
import com.jfinal.plugin.redis.Redis;
import com.qcloud.cos.utils.Md5Utils;
import com.zhibao.crm.saas.entity.SaasDb;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.lang3.StringUtils;

public class CommonUtils {

   public static boolean isOdd(int a) {
      return (a & 1) != 1;
   }

   public static String randomNum(Integer size) {
      String[] codees = new String[]{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9"};
      String code = "";

      for(int i = 0; i < size.intValue(); ++i) {
         int j = (int)(Math.random() * 10.0D);
         code = code + codees[j];
      }

      return code;
   }

   public static boolean isMobileDevice(HttpServletRequest request) {
      String requestHeader = request.getHeader("user-agent");
      String[] deviceArray = new String[]{"android", "mac os", "windows phone", "mobile"};
      if(requestHeader == null) {
         return false;
      } else {
         requestHeader = requestHeader.toLowerCase();
         String[] var3 = deviceArray;
         int var4 = deviceArray.length;

         for(int var5 = 0; var5 < var4; ++var5) {
            String device = var3[var5];
            if(requestHeader.indexOf(device) != -1) {
               return true;
            }
         }

         return false;
      }
   }

   public static SaasDb chooseDbByCompId(String corpid) throws Exception {
      SaasDb dbDto = null;

      try {
         Redis.use().del("Db" + corpid);
         String e = (String)Redis.use().get("Db" + corpid);
         if(StringUtils.isNotBlank(e)) {
            dbDto = (SaasDb)JSONObject.parseObject(e, SaasDb.class);
         } else {
            Record plugin = Db.use().findFirst("select * from crm_saas_db where corpid = ? ", new Object[]{corpid});
            if(plugin != null) {
               dbDto = new SaasDb();
               dbDto.setCorpid((String)plugin.get("corpid"));
               dbDto.setDbHost((String)plugin.get("db_host"));
               dbDto.setDbUser((String)plugin.get("db_user"));
               dbDto.setDbName((String)plugin.get("db_name"));
               dbDto.setDbPwd((String)plugin.get("db_pwd"));
               dbDto.setDbId((Long)plugin.get("db_id"));
               dbDto.setServeUrl((String)plugin.get("serve_url"));
               Redis.use().set("Db" + corpid, JSONObject.toJSONString(plugin));
            }
         }

         if(dbDto == null) {
            return null;
         } else {
            if(DbKit.getConfig(dbDto.getDbName()) == null) {
               DruidPlugin plugin1 = new DruidPlugin("jdbc:mysql://" + dbDto.getDbHost() + "/" + dbDto.getDbName() + "?characterEncoding=utf8&useSSL=false&zeroDateTimeBehavior=convertToNull&tinyInt1isBit=false", dbDto.getDbUser(), dbDto.getDbPwd());
               plugin1.start();
               ActiveRecordPlugin arp = new ActiveRecordPlugin(dbDto.getDbName(), plugin1);
               arp.start();
            }

            return dbDto;
         }
      } catch (Exception var5) {
         return null;
      }
   }

   public static void readTxtFile(String filePath) {
      try {
         String e = "GBK";
         File file = new File(filePath);
         if(file.isFile() && file.exists()) {
            InputStreamReader read = new InputStreamReader(new FileInputStream(file), e);
            BufferedReader bufferedReader = new BufferedReader(read);
            String lineTxt = null;

            while((lineTxt = bufferedReader.readLine()) != null) {
               System.out.println(Md5Utils.md5Hex(lineTxt));
            }

            read.close();
         } else {
            System.out.println("找不到指定的文件");
         }
      } catch (Exception var6) {
         System.out.println("读取文件内容出错");
         var6.printStackTrace();
      }

   }

   public static String humpToUnderlineForJsonKeys(JSONObject jsonObject) {
      JSONObject newJsonObject = new JSONObject();
      Iterator var2 = jsonObject.keySet().iterator();

      while(var2.hasNext()) {
         String key = (String)var2.next();
         String newKey = humpToUnderline(key);
         newJsonObject.put(newKey, jsonObject.get(key));
      }

      return newJsonObject.toString();
   }

   public static String humpToUnderline(String str) {
      StringBuffer sb = new StringBuffer();
      if(StringUtils.isNotEmpty(str)) {
         Matcher matcher = Pattern.compile("[A-Z]").matcher(str);

         while(matcher.find()) {
            matcher.appendReplacement(sb, "_" + matcher.group(0).toLowerCase());
         }

         matcher.appendTail(sb);
      }

      return sb.toString();
   }

   public static void main(String[] args) {
      String filePath = "D:\\360Downloads\\1111.txt";
      readTxtFile(filePath);
   }
}
